// Last updated on 4/27/98
// Look at your rom IMAGEs visually!
// u = up a line
// U = up a page
// d = down a line
// D = down a page
// n = left one block
// m = right one block
// r = up one byte
// <space> = down 1 byte  If the image appears blurred,
//                        it's 1 byte out of sync.
//
// 1,2 = wider,narower
// 3,4 = taller shorter
//
// l = turns off and on the red background lines
//
//  By Micah Dowty. Hevily modified By David Tucker(dbt@dana.ucc.nau.edu).
//  If you make any major changes, send me a copy! I'm at
//      MicahJD@aol.com
//Changes:  recompiled using allegro and djgpp, mutch faster =)
//todo:  Still needs to be optimized (especialy the clear screen routine)

//#include <stdio.h>
//#include <graph.h>
//#include <conio.h>
//#include <stdlib.h>
//#include <iostream.h>
//#define RGB(r,g,b) (((long) ((b) << 8 | (g)) << 8) | (r))
//long tmp, pal[256];

#include <stdlib.h>
#include <stdio.h>
#include "allegro.h"

#define row_max 21
#define columb_max 35


void vb_clear_all();


void main( int argc, char *argv[] ) {
    /*Alegro Code*/
    PALLETE pallete;
    RGB temp;
    /*End Alegro Code*/

    long filoffset = 0;
    int gap = 9;
    int row    = row_max; //21   // set the #of Rows
    int columb = columb_max; //35   // set the # of Columbs
 
    int exitflag = 0;
    FILE *infile;
    int i,j,k,l,mode;
    int byte1,byte2,byte3,byte4;
    char buffer [80];
    char a,b,c,d,e;               

    /*Alegro Code*/
    allegro_init();
    install_keyboard(); 
    set_gfx_mode(GFX_VGA, 320, 200, 0, 0);

    /* Set palet to red*/
    for (i=0; i<256; i++) {
        pallete[i].r = 50;
        pallete[i].g = 0;
        pallete[i].b = 0;
    }

    /* fill our pallete with a gradually altering sequence of colors */
    for ( i = 0,j=0; j < 64; i+=1,j +=16) {
        pallete[i].r = j;
        pallete[i].g = j;
        pallete[i].b = j;
    }

    set_pallete(pallete);

    /*End Alegro Code*/

/*  // Old VC++ Code
    // set to 320*200*256 graphics mode.
    mode = _MRES256COLOR;
    if( !_setvideomode( mode ) ) {
          cout << "Error! Could not establish Video Mode" << endl;
          exit( 1 );
    }

    // Make sure all palette numbers are valid. 
    for( i = 0; i < 256; i++ )
         pal[i] = RGB( 50, 0, 0 );    // set all colors to red...

    //set the first 4 colors to grey
    for( i = 0,j=0; j < 64; j +=16){
         pal[i++] = RGB( j, j, j );
    }

    _remapallpalette( pal );
*/        
        // Make Me faster!
    vb_clear_all();


    // open file passed on command line
    if( argc < 2 )
        infile = fopen("vb_rom.vb","rb");
    else
        infile = fopen( argv[1],"rb");

 
    //_settextposition( 25,2 );
    sprintf(buffer, "%li - %li",filoffset,filoffset+(16)*columb*row);
    //_outtext( buffer );
    textout(screen, font, buffer, 0, 191, 255);


    while (!exitflag) {
        fseek(infile,filoffset,SEEK_SET);

        for (i=0;i<row;i++) {
            for (l=0;l<columb;l++) {
                for (k=0;k<8;k++) {
                    byte1 = getc(infile);
                    byte2 = getc(infile);

                    for (j=0;j<4;j++){
                        a = ((byte1 >> (j*2)) & 3);       // Find the color
                        //_setcolor( a );
                        //_setpixel((j)+(l*gap)+1,(i*gap)+(k)+1);
                                            putpixel(screen,(j)+(l*gap)+1,(i*gap)+(k)+1, a);
                    }
                    for (j=0;j<4;j++){
                        a = ((byte2 >> (j*2)) & 3);       // Find the color
                        //_setcolor( a );
                        //_setpixel((j)+4+(l*gap)+1,(i*gap)+(k)+1);
                                            putpixel(screen,(j)+4+(l*gap)+1,(i*gap)+(k)+1, a);
                    }
                }
            }  
        }

        a = readkey();
        a = (a & 0xFF);

        //a = getch();
        if (a=='u') filoffset -= (16)*columb; // Move 1 coloumn
        if (a=='d') filoffset += (16)*columb;
        if (a=='U') filoffset -= (16)*columb*row;  // A whole page
        if (a=='D') filoffset += (16)*columb*row;
        if (a=='m') filoffset -= 16;      // one cell
        if (a=='n') filoffset += 16;
        if (a==' ') filoffset++;          // one byte
        if (a=='z') filoffset--;          // one byte

        if (a=='1') if(row < row_max) row += 1;
        if (a=='2') if(row > 1) {row -= 1; vb_clear_all();}
        if (a=='3') if(columb < columb_max) columb += 1;
        if (a=='4') if(columb > 1) {columb -= 1; vb_clear_all();}

        if (a=='l') {if(gap == 9) gap = 8; else gap = 9; vb_clear_all();}

        if (a==27) exitflag = 1;
          
        //_settextposition( 25,2 );
        sprintf(buffer, "%li - %li",filoffset,filoffset+(16)*columb*row);
        //_outtext( buffer );
                textout(screen, font, buffer, 0, 191, 255);
    };
    fclose(infile);
    //_setvideomode( _DEFAULTMODE     );
}
  
void vb_clear_all()
{
    int i,j;
    //_clearscreen( _GCLEARSCREEN );

    // set the background to red (makes it easier to 
    // reasemble the pictures later)
    //_setcolor( 200 );
    for(i=0;i<316;i++)
        for(j=0;j<190;j++)
              putpixel(screen,i,j, 200);
 }

